#include "led.h"

#include <qcombobox.h>
#include <qstringlist.h>

#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#include "sharp_char.h"

Led::Led(QWidget *parent, const char *name)
: LedBase(parent, name, true)
{
  updateStatus(0);
}

Led::~Led()
{
}

void Led::updateStatus(int index)
{
  status->clear();
  QString l;
  switch (index) {
    case 0:
      l = "LED_COLLIE_0_DEFAULT;LED_COLLIE_0_OFF;LED_COLLIE_0_ON;LED_COLLIE_0_FASTBLINK;LED_COLLIE_0_SLOWBLINK";
      break;
    case 1:
      l = "LED_COLLIE_1_DEFAULT;LED_COLLIE_1_OFF;LED_COLLIE_1_ON;LED_COLLIE_1_FLASHON;LED_COLLIE_1_FLASHOFF;LED_COLLIE_1_VFSTBLINK;LED_COLLIE_1_FASTBLINK;LED_COLLIE_1_NORMBLINK;LED_COLLIE_1_SLOWBLINK;LED_COLLIE_1_SOFTBLINK;LED_COLLIE_1_SOFTFLASH";
      break;
  };
  status->insertStringList(QStringList::split(';', l));
}

void Led::setStatus()
{
	int fd;
  sharp_led_status st;

  fd = open ("/dev/sharp_led", O_WRONLY);
  st.which = led->currentItem() + SHARP_LED_COLLIE_0;
  st.status = status->currentItem();
  ioctl(fd, SHARP_LED_SETSTATUS, &st);
}

